/*
   USB/COM port connection library
   by paul69, v0.00, 2003-02-08, <e2500@narod.ru>

   Supported camera:
      (not tested)
*/
#pragma hdrstop

#include <string.h>
#include "lib\dsc_connect.h"

////////////////////////////////////////////////////////////////////////////////
//
//
//
//
//

DSC::~DSC()
{
}

DSC::DSC(const char* _comment)
{
   strncpy(comment, _comment, sizeof(comment)-1);
   comment[ sizeof(comment)-1 ] = '\0';
}

bool DSC::SetStr(int reg, const char* s) const
{
   return SetVar(reg, s, strlen(s) );
}

////////////////////////////////////////////////////////////////////////////////

bool TResponce::append(const void* data, unsigned _size)
{
   char* prev = ptr;
   int new_size = size + _size;

   ptr = new char[new_size];

   if( !ptr )
   {
      ptr = prev;
      return false;
   }

   if( size )
      memcpy( ptr, prev, size );

   delete [] prev;

   if( _size )
      memcpy( ptr+size, data, _size );

   size = new_size;
   return true;
}

const char* TResponce::PrepareStr()
{
   const char* s = ptr;
   char* d = ptr;
   for(int i=0; i<size; ++i)
   {
      if( !s[i] ) break;
      if( s[i] == '\r' ) continue;

      *d++ = s[i];
   }
   d[0] = '\0';
   return ptr;
}

